"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEventAttribute = void 0;
const types_1 = require("../../types");
function default_1(attName, value) {
    if (isEventAttribute(attName)) {
        const isCatch = attName.startsWith('catch');
        let eventName;
        if (isCatch) {
            eventName = attName.substring(5);
        }
        else {
            eventName = attName.substring(2);
        }
        eventName = eventName.replace(eventName[0], eventName[0].toLowerCase());
        return (0, types_1.eventAttributeNode)(eventName, (0, types_1.dataBindingNode)(value), isCatch);
    }
    return null;
}
exports.default = default_1;
function isEventAttribute(attName) {
    if (attName !== 'on' && attName !== 'catch') {
        let startLetter;
        if (attName.startsWith('on')) {
            startLetter = attName.substring(2, 3);
        }
        if (attName.startsWith('catch')) {
            startLetter = attName.substring(5, 6);
        }
        if (startLetter && /[A-Z]/.test(startLetter)) {
            return true;
        }
    }
    return false;
}
exports.isEventAttribute = isEventAttribute;
//# sourceMappingURL=index.js.map