"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("../types");
const AttributesParseer = [
    require('./unsupport/index').default,
    require('./event/index').default,
    require('./class/index').default,
    require('./style/index').default,
    require('./ref/index').default,
    require('./slot/index').default
];
function default_1(xmlElement) {
    const attributes = [];
    if (xmlElement.attributes) {
        for (const key of Object.keys(xmlElement.attributes)) {
            const value = xmlElement.attributes[key];
            let att;
            for (const func of AttributesParseer) {
                att = func(key, value);
                if (att) {
                    break;
                }
            }
            if (att) {
                if (att.type !== 'UnSupportAttributeNode')
                    attributes.push(att);
            }
            else {
                attributes.push((0, types_1.attributeNode)(key, (0, types_1.dataBindingNode)(value)));
            }
        }
    }
    return attributes;
}
exports.default = default_1;
//# sourceMappingURL=index.js.map