"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const xml2js_1 = __importDefault(require("../../libs/xml2js"));
const IXmlNode_1 = require("./IXmlNode");
const types_1 = require("./types");
class Context {
    constructor(source) {
        this.doc = (0, types_1.document)([], [], (0, types_1.fragmentNode)([]));
        const content = `<root>${source}</root>`;
        const xml = (0, xml2js_1.default)(content, { ignoreComment: false }).elements[0];
        (0, IXmlNode_1.initParent)(xml);
        this._rootXml = xml;
    }
    // 重置上下文。开始编译一个文件的时候调用
    static resetContext(source) {
        Context.currentContenxt = new Context(source);
        return Context.currentContenxt;
    }
    get document() {
        return this.doc;
    }
    get rootXml() {
        return this._rootXml;
    }
}
exports.default = Context;
//# sourceMappingURL=context.js.map