"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isForNode = void 0;
const IXmlNode_1 = require("../../IXmlNode");
const types_1 = require("../../types");
const index_1 = require("../index");
const ForAttributeKey = 'a:for';
const ForItemAttributeKey = 'a:for-item';
const ForIndexAttributeKey = 'a:for-index';
const ForKeyAttributeKey = 'key';
const ForKey2AttributeKey = 'a:key';
// const aKeyAtt = findFirstAttAndRemove(node, 'a:key');
// const keyAtt = findFirstAttAndRemove(node, 'key');
function default_1(xmlElement) {
    if (isForNode(xmlElement)) {
        const forNode = (0, types_1.forElementNode)((0, types_1.dataBindingNode)((0, IXmlNode_1.attributeValueAndRemove)(xmlElement.attributes, ForAttributeKey)), null);
        forNode.item = (0, IXmlNode_1.attributeValueAndRemove)(xmlElement.attributes, ForItemAttributeKey);
        forNode.index = (0, IXmlNode_1.attributeValueAndRemove)(xmlElement.attributes, ForIndexAttributeKey);
        const key1 = (0, IXmlNode_1.attributeValueAndRemove)(xmlElement.attributes, ForKeyAttributeKey);
        const key2 = (0, IXmlNode_1.attributeValueAndRemove)(xmlElement.attributes, ForKey2AttributeKey);
        if (key1 || key2) {
            let key = (key1 || key2).trim();
            const itemName = forNode.item || 'item';
            const indexName = forNode.index || 'index';
            // 提供 *this 支持
            if (key === '*this') {
                key = `{{${itemName}}}`;
            }
            // 如果是字符串且未被 {{}} 包裹, 则自动包裹一层
            // 需要区分 key 名称为 index 的情况
            else if (!/\{\{.+\}\}/.test(key)) {
                key = key === indexName ? `{{${indexName}}}` : `{{${itemName}.${key}}}`;
            }
            xmlElement.attributes['key'] = key;
        }
        forNode.element = (0, index_1.parseElement)(xmlElement);
        return forNode;
    }
    return null;
}
exports.default = default_1;
function isForNode(xmlElement) {
    if (!xmlElement.attributes)
        return false;
    return Object.prototype.hasOwnProperty.call(xmlElement.attributes, ForAttributeKey);
}
exports.isForNode = isForNode;
//# sourceMappingURL=index.js.map