"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../../../../../utils/index");
const IXmlNode_1 = require("../../IXmlNode");
const types_1 = require("../../types");
const index_2 = require("../index");
const IFAttributeKey = 'a:if';
const ElseIfAttributeKey = 'a:elif';
const ElseAttributeKey = 'a:else';
function default_1(xmlElement) {
    if (isIfNode(xmlElement)) {
        const ifNode = (0, types_1.ifElementNode)((0, types_1.dataBindingNode)((0, IXmlNode_1.attributeValueAndRemove)(xmlElement.attributes, IFAttributeKey)), (0, index_2.parseElement)(xmlElement));
        let lastElement = xmlElement;
        while (lastElement) {
            lastElement = (0, IXmlNode_1.findNextSibling)(lastElement);
            if (!lastElement) {
                break;
            }
            if (isElseNode(lastElement)) {
                (0, IXmlNode_1.attributeValueAndRemove)(lastElement.attributes, ElseAttributeKey);
                ifNode.elseElement = (0, types_1.elseElementNode)((0, index_2.parseElement)(lastElement));
                // lastElement.ignor = true;
            }
            else if (isElseIfNode(lastElement)) {
                ifNode.elseIfElements.push((0, types_1.elseIfElementNode)((0, types_1.dataBindingNode)((0, IXmlNode_1.attributeValueAndRemove)(lastElement.attributes, ElseIfAttributeKey)), (0, index_2.parseElement)(lastElement)));
                // lastElement.ignor = true;
            }
            else {
                break;
            }
        }
        return ifNode;
    }
    return null;
}
exports.default = default_1;
function isIfNode(xmlElement) {
    if (!xmlElement.attributes)
        return false;
    return (0, index_1.hasOwnProperty)(xmlElement.attributes, IFAttributeKey);
}
function isElseIfNode(xmlElement) {
    if (!xmlElement.attributes)
        return false;
    return (0, index_1.hasOwnProperty)(xmlElement.attributes, ElseIfAttributeKey);
}
function isElseNode(xmlElement) {
    if (!xmlElement.attributes)
        return false;
    return (0, index_1.hasOwnProperty)(xmlElement.attributes, ElseAttributeKey);
}
//# sourceMappingURL=index.js.map