"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseSubElements = exports.parseElement = void 0;
const utils_1 = require("../../generate/utils");
const index_1 = __importDefault(require("../attribute/index"));
const comment_1 = __importDefault(require("../comment"));
const context_1 = __importDefault(require("../context"));
const types_1 = require("../types");
const block_1 = __importDefault(require("./block"));
const for_1 = __importDefault(require("./for"));
const index_2 = __importDefault(require("./if-else/index"));
const import_1 = __importStar(require("./import"));
const include_1 = __importDefault(require("./include"));
const slot_1 = __importDefault(require("./slot"));
const slot_scope_1 = __importDefault(require("./slot-scope"));
const template_1 = __importDefault(require("./template"));
function parseElement(xmlElement) {
    xmlElement.ignor = true;
    if (xmlElement.type === 'text') {
        return (0, types_1.textNode)((0, types_1.dataBindingNode)(xmlElement.text.replace(/(^\s*)|(\s*$)/g, '').trim()));
    }
    if (xmlElement.type === 'comment') {
        // 注释
        return (0, comment_1.default)(xmlElement);
    }
    // 优先处理指令
    if (xmlElement.attributes) {
        // for 的优先级大于 if
        let element = (0, for_1.default)(xmlElement);
        if (element) {
            return element;
        }
        element = (0, index_2.default)(xmlElement);
        if (element) {
            return element;
        }
        element = (0, slot_scope_1.default)(xmlElement);
        if (element) {
            return element;
        }
    }
    // 处理特定的节点
    switch (xmlElement.name) {
        case 'template': {
            // 模板
            const node = (0, template_1.default)(xmlElement);
            if (node && (0, types_1.isUseTemplateNode)(node)) {
                return node;
            }
            else if (node && (0, types_1.isTemplateNode)(node)) {
                context_1.default.currentContenxt.document.templates.push(node);
            }
            return null;
        }
        case 'import': {
            const node = (0, import_1.default)(xmlElement);
            context_1.default.currentContenxt.document.imports.push(node);
            return null;
        }
        case 'import-sjs': {
            const node = (0, import_1.importSjsElment)(xmlElement);
            context_1.default.currentContenxt.document.imports.push(node);
            return null;
        }
        case 'include': {
            const node = (0, include_1.default)(xmlElement);
            return node;
        }
        case 'slot': {
            const node = (0, slot_1.default)(xmlElement);
            return node;
        }
        case 'block': {
            const node = (0, block_1.default)(xmlElement);
            return node;
        }
    }
    // 解析最简单的元素节点
    const elNode = (0, types_1.elementNode)(xmlElement.name, (0, utils_1.uuid)(), (0, index_1.default)(xmlElement), []);
    elNode.children = parseSubElements(xmlElement);
    return elNode;
}
exports.parseElement = parseElement;
function parseSubElements(xmlElement) {
    if (xmlElement.elements) {
        return xmlElement.elements
            .map((el) => (el.ignor ? null : parseElement(el)))
            .filter((el) => el);
    }
    return [];
}
exports.parseSubElements = parseSubElements;
//# sourceMappingURL=index.js.map