"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("@morjs/utils");
const index_1 = __importDefault(require("../attributes/index"));
const helper_databinding_1 = require("../helper-databinding");
const index_2 = __importDefault(require("./index"));
function default_1(node, context) {
    context.mergeDatabindingVars(node.name);
    const attributes = node.attributes.map((att) => (0, index_1.default)(node, att, context));
    attributes.push(utils_1.babelTypes.jsxAttribute(utils_1.babelTypes.jsxIdentifier('slots'), utils_1.babelTypes.jsxExpressionContainer(utils_1.babelTypes.identifier('$children'))));
    // NOTE: 手动添加绑定变量
    context.dataBindingVars.add('$children');
    if (node.name && node.name.express) {
        attributes.push(utils_1.babelTypes.jsxAttribute(utils_1.babelTypes.jsxIdentifier('name'), (0, helper_databinding_1.databindingForAttribute)(node.name)));
    }
    if (node.attributes.length > 0) {
        attributes.push(utils_1.babelTypes.jsxAttribute(utils_1.babelTypes.jsxIdentifier('$scopeKeys'), utils_1.babelTypes.jsxExpressionContainer(utils_1.babelTypes.arrayExpression(node.attributes.map((att) => utils_1.babelTypes.stringLiteral(att.name))))));
    }
    const children = [];
    if (node.children.length > 0) {
        children.push(utils_1.babelTypes.jsxText('\r\n'));
        node.children.forEach((item) => children.push((0, index_2.default)(item, context)));
        children.push(utils_1.babelTypes.jsxText('\r\n'));
    }
    return utils_1.babelTypes.jsxElement(utils_1.babelTypes.jsxOpeningElement(utils_1.babelTypes.jsxIdentifier('$rm.Slot'), attributes, children.length === 0), utils_1.babelTypes.jsxClosingElement(utils_1.babelTypes.jsxIdentifier('$rm.Slot')), children, null);
}
exports.default = default_1;
//# sourceMappingURL=SlotNode.js.map