"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAppCssResourceName = exports.getCssResourcePath = exports.getAxmlResourcePath = void 0;
const utils_1 = require("@morjs/utils");
const path = __importStar(require("path"));
const constants_1 = require("../../constants");
function getAxmlResourcePath(options) {
    if (options.templateFilePath)
        return options.templateFilePath;
    const conditionalFileExt = options.conditionalCompileFileExt || [
        constants_1.defaultConditionalFileExt
    ];
    const exts = (0, utils_1.expandExtsWithConditionalExt)(['.axml'], conditionalFileExt);
    const dir = path.dirname(options.resourcePath);
    const filePath = (0, utils_1.lookupFile)(dir, [options.name], exts, {
        pathOnly: true,
        depth: 1
    });
    if (filePath) {
        const axmlFile = './' + (0, utils_1.slash)(path.relative(dir, filePath));
        return options.isAtomicMode ? axmlFile + '.js' : axmlFile;
    }
}
exports.getAxmlResourcePath = getAxmlResourcePath;
function getStylePath(prefix, options, isApp = false) {
    const conditionalFileExt = options.conditionalCompileFileExt || [
        constants_1.defaultConditionalFileExt
    ];
    // .h5.acss  > .acss
    const exts = (0, utils_1.expandExtsWithConditionalExt)(['.acss'], conditionalFileExt);
    const result = (0, utils_1.lookupFile)(path.dirname(prefix), [isApp ? 'app' : path.basename(prefix)], exts, { pathOnly: true, depth: 1 });
    if (result) {
        return './' + (0, utils_1.slash)(path.relative(path.dirname(prefix), result));
    }
}
function getCssResourcePath(options) {
    if (options.styleFilePath)
        return options.styleFilePath;
    const filePath = path.resolve(options.resourcePath, '../' + options.name);
    return getStylePath(filePath, options);
}
exports.getCssResourcePath = getCssResourcePath;
function getAppCssResourceName(options) {
    if (options.appStyleFilePath)
        return options.appStyleFilePath;
    const appPath = path.resolve(options.rootPath, './app');
    return getStylePath(appPath, options, true);
}
exports.getAppCssResourceName = getAppCssResourceName;
//# sourceMappingURL=file-utils.js.map