"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AtomicFileGeneratePlugin = void 0;
const plugin_compiler_alipay_1 = require("@morjs/plugin-compiler-alipay");
const utils_1 = require("@morjs/utils");
/**
 * 非 bundle 模式下
 * 修改 模版 为 axml.js
 * 修改 样式 为 css
 */
class AtomicFileGeneratePlugin {
    constructor() {
        this.name = 'MorWebAtomicFileGeneratePlugin';
    }
    apply(runner) {
        this.alterEntryNameForNonBundleMode(runner);
    }
    alterEntryNameForNonBundleMode(runner) {
        const styleExtRegExp = new RegExp(`\\${plugin_compiler_alipay_1.fileType.style}$`);
        runner.hooks.addEntry.tap(this.name, (entryInfo) => {
            if (entryInfo.entry.entryFileType === utils_1.EntryFileType.template ||
                entryInfo.entry.entryFileType === utils_1.EntryFileType.sjs) {
                const entryName = `${entryInfo.name}.js`;
                entryInfo.entry.fullEntryName = entryName;
                entryInfo.name = entryName;
            }
            else if (entryInfo.entry.entryFileType === utils_1.EntryFileType.style) {
                const entryName = entryInfo.name.replace(styleExtRegExp, '.css');
                entryInfo.entry.fullEntryName = entryName;
                entryInfo.name = entryName;
            }
            return entryInfo;
        });
    }
}
exports.AtomicFileGeneratePlugin = AtomicFileGeneratePlugin;
//# sourceMappingURL=atomicFileGeneratePlugin.js.map