import { EntryBuilderHelpers, Plugin, Runner, UserConfig, webpack, WebpackWrapper } from '@morjs/utils';
/**
 * Web 相关 jsx 入口文件生成
 */
export declare class GenerateJSXEntryPlugin implements Plugin {
    wrapper: WebpackWrapper;
    name: string;
    constructor(wrapper: WebpackWrapper);
    apply(runner: Runner<any>): void;
    /**
     * 是否开启了当前插件
     */
    shouldAutoGenerateEntries(runner: Runner): boolean;
    /**
     * 忽略用于生成 entries 的虚拟目录, 避免 watchpack 错误监听虚拟目录导致二次编译的触发
     */
    ignoreEntryFakeFolder(userConfig: UserConfig, wrapper: WebpackWrapper): void;
    /**
     * 生成 web 需要的 entry 文件
     */
    generateEntryFiles(runner: Runner, entryHelpers: EntryBuilderHelpers): Promise<webpack.EntryObject>;
}
